//
// engine_api.cpp
//
// Implementation of Half-Life engine functions
//

#include "main.h"
#include <io.h>

int pfnPrecacheModel(char* s) {
   if (strncmp(s, "models/hostage", 14) == 0 ||
      strstr(s, "spetsnaz") != NULL ||
      strstr(s, "militia") != NULL) {
      return g_engfuncs.pfnPrecacheModel("models/hostage.mdl");
   }
   return (*g_engfuncs.pfnPrecacheModel)(s);
}

int pfnPrecacheSound(char* s) {
   if (strncmp(s, "hostage/", 8) == 0) {
      static int i = 0;
      switch (i++ % 5) {
      case 0:
         return (*g_engfuncs.pfnPrecacheSound)("hostage/hos1.wav");
      case 1:
         return (*g_engfuncs.pfnPrecacheSound)("hostage/hos2.wav");
      case 2:
         return (*g_engfuncs.pfnPrecacheSound)("hostage/hos3.wav");
      case 3:
         return (*g_engfuncs.pfnPrecacheSound)("hostage/hos4.wav");
      case 4:
         return (*g_engfuncs.pfnPrecacheSound)("hostage/hos5.wav");
      }
   }
   return (*g_engfuncs.pfnPrecacheSound)(s);
}

void pfnSetModel(edict_t *e, const char *m) {
   if (strncmp(m, "models/hostage", 14) == 0) {
      g_engfuncs.pfnSetModel(e, "models/hostage.mdl");
      return;
   }
   (*g_engfuncs.pfnSetModel)(e, m);
}

int pfnModelIndex(const char *m) {
   if (strncmp(m, "models/hostage", 14) == 0) {
      return g_engfuncs.pfnModelIndex("models/hostage.mdl");
   }
   return (*g_engfuncs.pfnModelIndex)(m);
}

int pfnModelFrames(int modelIndex) {
   return (*g_engfuncs.pfnModelFrames)(modelIndex);
}

void pfnSetSize(edict_t *e, const float *rgflMin, const float *rgflMax) {
   (*g_engfuncs.pfnSetSize)(e, rgflMin, rgflMax);
}

void pfnChangeLevel(char* s1, char* s2) {
   (*g_engfuncs.pfnChangeLevel)(s1, s2);
}

void pfnGetSpawnParms(edict_t *ent) {
   (*g_engfuncs.pfnGetSpawnParms)(ent);
}

void pfnSaveSpawnParms(edict_t *ent) {
   (*g_engfuncs.pfnSaveSpawnParms)(ent);
}

float pfnVecToYaw(const float *rgflVector) {
   return (*g_engfuncs.pfnVecToYaw)(rgflVector);
}

void pfnVecToAngles(const float *rgflVectorIn, float *rgflVectorOut) {
   (*g_engfuncs.pfnVecToAngles)(rgflVectorIn, rgflVectorOut);
}

void pfnMoveToOrigin(edict_t *ent, const float *pflGoal, float dist, int iMoveType) {
   (*g_engfuncs.pfnMoveToOrigin)(ent, pflGoal, dist, iMoveType);
}

void pfnChangeYaw(edict_t* ent) {
   (*g_engfuncs.pfnChangeYaw)(ent);
}

void pfnChangePitch(edict_t* ent) {
   (*g_engfuncs.pfnChangePitch)(ent);
}

edict_t* pfnFindEntityByString(edict_t *pEdictStartSearchAfter, const char *pszField, const char *pszValue) {
   return (*g_engfuncs.pfnFindEntityByString)(pEdictStartSearchAfter, pszField, pszValue);
}

int pfnGetEntityIllum(edict_t* pEnt) {
   return (*g_engfuncs.pfnGetEntityIllum)(pEnt);
}

edict_t* pfnFindEntityInSphere(edict_t *pEdictStartSearchAfter, const float *org, float rad) {
   return (*g_engfuncs.pfnFindEntityInSphere)(pEdictStartSearchAfter, org, rad);
}

edict_t* pfnFindClientInPVS(edict_t *pEdict) {
   return (*g_engfuncs.pfnFindClientInPVS)(pEdict);
}

edict_t* pfnEntitiesInPVS(edict_t *pplayer) {
   return (*g_engfuncs.pfnEntitiesInPVS)(pplayer);
}

void pfnMakeVectors(const float *rgflVector) {
   (*g_engfuncs.pfnMakeVectors)(rgflVector);
}

void pfnAngleVectors(const float *rgflVector, float *forward, float *right, float *up) {
   (*g_engfuncs.pfnAngleVectors)(rgflVector, forward, right, up);
}

edict_t* pfnCreateEntity(void) {
   return (*g_engfuncs.pfnCreateEntity)();
}

void pfnRemoveEntity(edict_t* e) {
   (*g_engfuncs.pfnRemoveEntity)(e);
}

edict_t* pfnCreateNamedEntity(int className) {
   return (*g_engfuncs.pfnCreateNamedEntity)(className);
}

void pfnMakeStatic(edict_t *ent) {
   (*g_engfuncs.pfnMakeStatic)(ent);
}

int pfnEntIsOnFloor(edict_t *e) {
   return (*g_engfuncs.pfnEntIsOnFloor)(e);
}

int pfnDropToFloor(edict_t* e) {
   return (*g_engfuncs.pfnDropToFloor)(e);
}

int pfnWalkMove(edict_t *ent, float yaw, float dist, int iMode) {
   return (*g_engfuncs.pfnWalkMove)(ent, yaw, dist, iMode);
}

void pfnSetOrigin(edict_t *e, const float *rgflOrigin) {
   (*g_engfuncs.pfnSetOrigin)(e, rgflOrigin);
}

void pfnEmitSound(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch) {
   if (strncmp(sample, "hostage/", 8) == 0) {
      if (strncmp(sample, "hostage/huse/", 13) == 0) {
         switch (rand() % 5) {
         case 0:
            (*g_engfuncs.pfnEmitSound)(entity, channel, "hostage/hos1.wav", volume, attenuation, fFlags, pitch);
            break;
         case 1:
            (*g_engfuncs.pfnEmitSound)(entity, channel, "hostage/hos2.wav", volume, attenuation, fFlags, pitch);
            break;
         case 2:
            (*g_engfuncs.pfnEmitSound)(entity, channel, "hostage/hos3.wav", volume, attenuation, fFlags, pitch);
            break;
         case 3:
            (*g_engfuncs.pfnEmitSound)(entity, channel, "hostage/hos4.wav", volume, attenuation, fFlags, pitch);
            break;
         case 4:
         default:
            (*g_engfuncs.pfnEmitSound)(entity, channel, "hostage/hos5.wav", volume, attenuation, fFlags, pitch);
            break;
         }
         return;
      }
   }
   (*g_engfuncs.pfnEmitSound)(entity, channel, sample, volume, attenuation, fFlags, pitch);
}

void pfnEmitAmbientSound(edict_t *entity, float *pos, const char *samp, float vol, float attenuation, int fFlags, int pitch) {
   (*g_engfuncs.pfnEmitAmbientSound)(entity, pos, samp, vol, attenuation, fFlags, pitch);
}

void pfnTraceLine(const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr) {
   (*g_engfuncs.pfnTraceLine)(v1, v2, fNoMonsters, pentToSkip, ptr);
}

void pfnTraceToss(edict_t* pent, edict_t* pentToIgnore, TraceResult *ptr) {
   (*g_engfuncs.pfnTraceToss)(pent, pentToIgnore, ptr);
}

int pfnTraceMonsterHull(edict_t *pEdict, const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr) {
   return (*g_engfuncs.pfnTraceMonsterHull)(pEdict, v1, v2, fNoMonsters, pentToSkip, ptr);
}

void pfnTraceHull(const float *v1, const float *v2, int fNoMonsters, int hullNumber, edict_t *pentToSkip, TraceResult *ptr) {
   (*g_engfuncs.pfnTraceHull)(v1, v2, fNoMonsters, hullNumber, pentToSkip, ptr);
}

void pfnTraceModel(const float *v1, const float *v2, int hullNumber, edict_t *pent, TraceResult *ptr) {
   (*g_engfuncs.pfnTraceModel)(v1, v2, hullNumber, pent, ptr);
}

const char *pfnTraceTexture(edict_t *pTextureEntity, const float *v1, const float *v2 ) {
   return (*g_engfuncs.pfnTraceTexture)(pTextureEntity, v1, v2);
}

void pfnTraceSphere(const float *v1, const float *v2, int fNoMonsters, float radius, edict_t *pentToSkip, TraceResult *ptr) {
   (*g_engfuncs.pfnTraceSphere)(v1, v2, fNoMonsters, radius, pentToSkip, ptr);
}

void pfnGetAimVector(edict_t* ent, float speed, float *rgflReturn) {
   (*g_engfuncs.pfnGetAimVector)(ent, speed, rgflReturn);
}

void pfnServerCommand(char* str) {
   (*g_engfuncs.pfnServerCommand)(str);
}

void pfnServerExecute(void) {
   (*g_engfuncs.pfnServerExecute)();
}

void pfnClientCommand(edict_t* pEdict, char* szFmt, ...) {
   va_list argptr;
   static char string[1024];

   va_start(argptr, szFmt);
   _vsnprintf(string, sizeof(string), szFmt, argptr);
   va_end(argptr);

   (*g_engfuncs.pfnClientCommand)(pEdict, string);
}

void pfnParticleEffect(const float *org, const float *dir, float color, float count) {
   (*g_engfuncs.pfnParticleEffect)(org, dir, color, count);
}

void pfnLightStyle(int style, char* val) {
   (*g_engfuncs.pfnLightStyle)(style, val);
}

int pfnDecalIndex(const char *name) {
   return (*g_engfuncs.pfnDecalIndex)(name);
}

int pfnPointContents(const float *rgflVector) {
   return (*g_engfuncs.pfnPointContents)(rgflVector);
}

void pfnMessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed) {
   (*g_engfuncs.pfnMessageBegin)(msg_dest, msg_type, pOrigin, ed);
}

void pfnMessageEnd(void) {
   (*g_engfuncs.pfnMessageEnd)();
}

void pfnWriteByte(int iValue) {
   (*g_engfuncs.pfnWriteByte)(iValue);
}

void pfnWriteChar(int iValue) {
   (*g_engfuncs.pfnWriteChar)(iValue);
}

void pfnWriteShort(int iValue) {
   (*g_engfuncs.pfnWriteShort)(iValue);
}

void pfnWriteLong(int iValue) {
   (*g_engfuncs.pfnWriteLong)(iValue);
}

void pfnWriteAngle(float flValue) {
   (*g_engfuncs.pfnWriteAngle)(flValue);
}

void pfnWriteCoord(float flValue) {
   (*g_engfuncs.pfnWriteCoord)(flValue);
}

void pfnWriteString(const char *sz) {
   (*g_engfuncs.pfnWriteString)(sz);
}

void pfnWriteEntity(int iValue) {
   (*g_engfuncs.pfnWriteEntity)(iValue);
}

void pfnCVarRegister(cvar_t *pCvar) {
   (*g_engfuncs.pfnCVarRegister)(pCvar);
}

float pfnCVarGetFloat(const char *szVarName) {
   return (*g_engfuncs.pfnCVarGetFloat)(szVarName);
}

const char* pfnCVarGetString(const char *szVarName) {
   return (*g_engfuncs.pfnCVarGetString)(szVarName);
}

void pfnCVarSetFloat(const char *szVarName, float flValue) {
   (*g_engfuncs.pfnCVarSetFloat)(szVarName, flValue);
}

void pfnCVarSetString(const char *szVarName, const char *szValue) {
   (*g_engfuncs.pfnCVarSetString)(szVarName, szValue);
}

void pfnEngineFprintf( struct _iobuf *pfile, char *szFmt, ... ) {
   va_list argptr;
   static char string[1024];

   va_start(argptr, szFmt);
   _vsnprintf(string, sizeof(string), szFmt, argptr);
   va_end(argptr);

   (*g_engfuncs.pfnEngineFprintf)(pfile, string);
}

void pfnAlertMessage( ALERT_TYPE atype, char *szFmt, ... ) {
   va_list argptr;
   static char string[1024];

   va_start(argptr, szFmt);
   _vsnprintf(string, sizeof(string), szFmt, argptr);
   va_end(argptr);

   (*g_engfuncs.pfnAlertMessage)(atype, string);
}

void* pfnPvAllocEntPrivateData(edict_t *pEdict, int32 cb) {
   return (*g_engfuncs.pfnPvAllocEntPrivateData)(pEdict, cb);
}

void* pfnPvEntPrivateData(edict_t *pEdict) {
   return (*g_engfuncs.pfnPvEntPrivateData)(pEdict);
}

void pfnFreeEntPrivateData(edict_t *pEdict) {
   (*g_engfuncs.pfnFreeEntPrivateData)(pEdict);
}

const char* pfnSzFromIndex(int iString) {
   return (*g_engfuncs.pfnSzFromIndex)(iString);
}

int pfnAllocString(const char *szValue) {
   return (*g_engfuncs.pfnAllocString)(szValue);
}

entvars_t* pfnGetVarsOfEnt(edict_t *pEdict) {
   return (*g_engfuncs.pfnGetVarsOfEnt)(pEdict);
}

edict_t* pfnPEntityOfEntOffset(int iEntOffset) {
   return (*g_engfuncs.pfnPEntityOfEntOffset)(iEntOffset);
}

int pfnEntOffsetOfPEntity(const edict_t *pEdict) {
   return (*g_engfuncs.pfnEntOffsetOfPEntity)(pEdict);
}

int pfnIndexOfEdict(const edict_t *pEdict) {
   return (*g_engfuncs.pfnIndexOfEdict)(pEdict);
}

edict_t* pfnPEntityOfEntIndex(int iEntIndex) {
   return (*g_engfuncs.pfnPEntityOfEntIndex)(iEntIndex);
}

edict_t* pfnFindEntityByVars(entvars_t* pvars) {
   return (*g_engfuncs.pfnFindEntityByVars)(pvars);
}

void* pfnGetModelPtr(edict_t* pEdict) {
   return (*g_engfuncs.pfnGetModelPtr)(pEdict);
}

int pfnRegUserMsg(const char *pszName, int iSize) {
   return (*g_engfuncs.pfnRegUserMsg)(pszName, iSize);
}

void pfnAnimationAutomove(const edict_t* pEdict, float flTime) {
   (*g_engfuncs.pfnAnimationAutomove)(pEdict, flTime);
}

void pfnGetBonePosition(const edict_t* pEdict, int iBone, float *rgflOrigin, float *rgflAngles ) {
   (*g_engfuncs.pfnGetBonePosition)(pEdict, iBone, rgflOrigin, rgflAngles);
}

void pfnClientPrintf( edict_t* pEdict, PRINT_TYPE ptype, const char *szMsg ) {
   (*g_engfuncs.pfnClientPrintf)(pEdict, ptype, szMsg);
}

void pfnServerPrint( const char *szMsg ) {
   (*g_engfuncs.pfnServerPrint)(szMsg);
}

int pfnCmd_Argc(void) {
   return (*g_engfuncs.pfnCmd_Argc)();
}

const char *pfnCmd_Args(void) {
   return (*g_engfuncs.pfnCmd_Args)();
}

const char *pfnCmd_Argv (int argc) {
   return (*g_engfuncs.pfnCmd_Argv)(argc);
}

void pfnGetAttachment(const edict_t *pEdict, int iAttachment, float *rgflOrigin, float *rgflAngles ) {
   (*g_engfuncs.pfnGetAttachment)(pEdict, iAttachment, rgflOrigin, rgflAngles);
}

void pfnCRC32_Init(CRC32_t *pulCRC) {
   (*g_engfuncs.pfnCRC32_Init)(pulCRC);
}

void pfnCRC32_ProcessBuffer(CRC32_t *pulCRC, void *p, int len) {
   (*g_engfuncs.pfnCRC32_ProcessBuffer)(pulCRC, p, len);
}

void pfnCRC32_ProcessByte(CRC32_t *pulCRC, unsigned char ch) {
   (*g_engfuncs.pfnCRC32_ProcessByte)(pulCRC, ch);
}

CRC32_t pfnCRC32_Final(CRC32_t pulCRC) {
   return (*g_engfuncs.pfnCRC32_Final)(pulCRC);
}

int32 pfnRandomLong(int32 lLow, int32 lHigh) {
   return (*g_engfuncs.pfnRandomLong)(lLow, lHigh);
}

float pfnRandomFloat(float flLow, float flHigh) {
   return (*g_engfuncs.pfnRandomFloat)(flLow, flHigh);
}

void pfnSetView(const edict_t *pClient, const edict_t *pViewent ) {
   (*g_engfuncs.pfnSetView)(pClient, pViewent);
}

float pfnTime( void ) {
   return (*g_engfuncs.pfnTime)();
}

void pfnCrosshairAngle(const edict_t *pClient, float pitch, float yaw) {
   (*g_engfuncs.pfnCrosshairAngle)(pClient, pitch, yaw);
}

byte *pfnLoadFileForMe(char *filename, int *pLength) {
   int length = strlen(filename);
   if (strcmp(&filename[length - 4], ".nav") == 0) {
      int i = length;
      while (i > 0 && filename[i] != '/' && filename[i] != '\\')
         i--;
      if (i > 0)
         i++;
      if (access(va("czero\\maps\\%s", &filename[i]), 0) != -1) {
         return (*g_engfuncs.pfnLoadFileForMe)(va("../czero/maps/%s", &filename[i]), pLength);
      }
   }
   return (*g_engfuncs.pfnLoadFileForMe)(filename, pLength);
}

void pfnFreeFile(void *buffer) {
   (*g_engfuncs.pfnFreeFile)(buffer);
}

void pfnEndSection(const char *pszSectionName) {
   (*g_engfuncs.pfnEndSection)(pszSectionName);
}

int pfnCompareFileTime(char *filename1, char *filename2, int *iCompare) {
   return (*g_engfuncs.pfnCompareFileTime)(filename1, filename2, iCompare);
}

void pfnGetGameDir(char *szGetGameDir) {
   strcpy(szGetGameDir, "czero");
//   g_engfuncs.pfnGetGameDir(szGetGameDir);
}

void pfnCvar_RegisterVariable(cvar_t *variable) {
   (*g_engfuncs.pfnCvar_RegisterVariable)(variable);
}

void pfnFadeClientVolume(const edict_t *pEdict, int fadePercent, int fadeOutSeconds, int holdTime, int fadeInSeconds) {
   (*g_engfuncs.pfnFadeClientVolume)(pEdict, fadePercent, fadeOutSeconds, holdTime, fadeInSeconds);
}

void pfnSetClientMaxspeed(const edict_t *pEdict, float fNewMaxspeed) {
   (*g_engfuncs.pfnSetClientMaxspeed)(pEdict, fNewMaxspeed);
}

edict_t *pfnCreateFakeClient(const char *netname) {
   return (*g_engfuncs.pfnCreateFakeClient)(netname);
}

void pfnRunPlayerMove(edict_t *fakeclient, const float *viewangles, float forwardmove, float sidemove, float upmove, unsigned short buttons, byte impulse, byte msec ) {
   (*g_engfuncs.pfnRunPlayerMove)(fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, msec);
}

int pfnNumberOfEntities(void) {
   return (*g_engfuncs.pfnNumberOfEntities)();
}

char* pfnGetInfoKeyBuffer(edict_t *e) {
   return (*g_engfuncs.pfnGetInfoKeyBuffer)(e);
}

char* pfnInfoKeyValue(char *infobuffer, char *key) {
   return (*g_engfuncs.pfnInfoKeyValue)(infobuffer, key);
}

void pfnSetKeyValue(char *infobuffer, char *key, char *value) {
   (*g_engfuncs.pfnSetKeyValue)(infobuffer, key, value);
}

void pfnSetClientKeyValue(int clientIndex, char *infobuffer, char *key, char *value) {
   if (strcmp(key, "model") == 0) {
      if (strcmp(value, "spetsnaz") == 0) {
         char *models[] = {"urban", "gsg9", "sas", "gign"};
         g_engfuncs.pfnSetClientKeyValue(clientIndex, infobuffer, key, models[rand() % 4]);
         return;
      } else if (strcmp(value, "militia") == 0) {
         char *models[] = {"terror", "leet", "arctic", "guerilla"};
         g_engfuncs.pfnSetClientKeyValue(clientIndex, infobuffer, key, models[rand() % 4]);
         return;
      }
   }
   (*g_engfuncs.pfnSetClientKeyValue)(clientIndex, infobuffer, key, value);
}

int pfnIsMapValid(char *filename) {
   return (*g_engfuncs.pfnIsMapValid)(filename);
}

void pfnStaticDecal( const float *origin, int decalIndex, int entityIndex, int modelIndex ) {
   (*g_engfuncs.pfnStaticDecal)(origin, decalIndex, entityIndex, modelIndex);
}

int pfnPrecacheGeneric(char* s) {
   return (*g_engfuncs.pfnPrecacheGeneric)(s);
}

int pfnGetPlayerUserId(edict_t *e ) {
   return (*g_engfuncs.pfnGetPlayerUserId)(e);
}

void pfnBuildSoundMsg(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch, int msg_dest, int msg_type, const float *pOrigin, edict_t *ed) {
   (*g_engfuncs.pfnBuildSoundMsg)(entity, channel, sample, volume, attenuation, fFlags, pitch, msg_dest, msg_type, pOrigin, ed);
}

int pfnIsDedicatedServer(void) {
   return (*g_engfuncs.pfnIsDedicatedServer)();
}

void pfnAddServerCommand(char *cmd_name, void (*function)(void)) {
   g_engfuncs.pfnAddServerCommand(cmd_name, function);
}

