//
// util.cpp
//
// Utility code.  Really not optional after all.
//

#include "main.h"

int gmsgTextMsg = 0;
int gmsgSayText = 0;
int gmsgShowMenu = 0;

unsigned short FixedUnsigned16( float value, float scale ) {
   int output = value * scale;
   if ( output < 0 )
      output = 0;
   if ( output > 0xFFFF )
      output = 0xFFFF;
   return (unsigned short)output;
}

void ClientPrint( edict_t *pEntity, int msg_dest, const char *msg_name) {
   if (gmsgTextMsg == 0)
      gmsgTextMsg = REG_USER_MSG( "TextMsg", -1 );

   MESSAGE_BEGIN( MSG_ONE, gmsgTextMsg, NULL, pEntity );
      WRITE_BYTE( msg_dest );
      WRITE_STRING( msg_name );
   MESSAGE_END();
}

void UTIL_SayText( const char *pText, edict_t *pEdict ) {
   if (gmsgSayText == 0)
      gmsgSayText = REG_USER_MSG( "SayText", -1 );

   MESSAGE_BEGIN( MSG_ONE, gmsgSayText, NULL, pEdict );
      WRITE_BYTE( ENTINDEX(pEdict) );
      WRITE_STRING( pText );
   MESSAGE_END();
}

void GetModName(char *mod_name) {
   GET_GAME_DIR(mod_name); // ask the engine for the MOD directory path
   int length = strlen(mod_name); // get the length of the returned string

   // format the returned string to get the last directory name
   int fieldstop = length - 1;
   while ((mod_name[fieldstop] == '\\' || mod_name[fieldstop] == '/') && fieldstop > 0)
      fieldstop--; // shift back any trailing separator

   int fieldstart = fieldstop;
   while (mod_name[fieldstart] != '\\' && mod_name[fieldstart] != '/' && fieldstart > 0)
      fieldstart--; // shift back to the start of the last subdirectory name

   if (mod_name[fieldstart] == '\\' || mod_name[fieldstart] == '/')
      fieldstart++; // if we reached a separator, step over it

   // now copy the formatted string back onto itself character per character
   for (length = fieldstart; length <= fieldstop; length++)
      mod_name[length - fieldstart] = mod_name[length];
   mod_name[length - fieldstart] = 0; // terminate the string
}


// does a varargs printf into a temp buffer, so we don't need to have
// varargs versions of all text functions.
char *va(char *format, ...) {
   va_list     argptr;
   static char string[1024];

   va_start(argptr, format);
   _vsnprintf(string, sizeof(string), format, argptr);
   va_end (argptr);

   return string;  
}

void TerminateOnError(const char *string) {
   ALERT(at_error, "%s\n", string);
#ifdef _WIN32
   MessageBox(0, string, "Hookdll", MB_ICONERROR);
#endif
   exit(1);
}
